<?php
// ++=========================================================================++
// || vBadvanced CMPS v4.1.0 (для vBulletin 4.0 - 4.1)
// || © 2003-2011 vBadvanced.com - Все права защищены
// || http://vbadvanced.com
// || Русский перевод: Ivan A и zCarot
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE & ~8192);

global $vba_options, $pages, $vba_cusmodid, $home, $vba_cssinclude, $vba_dyna_inst, $vba_dyna_temps;

// ##### Alter vB Template ####################################################
function vbacmps_alter_vb_template($template, $addcode, $end = false)
{
	global $vbulletin;

	if ($end)
	{
		$vbulletin->templatecache[$template] = substr($vbulletin->templatecache[$template], 0, -2) . $addcode . '\';';
	}
	else
	{
		$start = substr($vbulletin->templatecache[$template], 0, 19);
		$end = substr($vbulletin->templatecache[$template], 19);
		$vbulletin->templatecache[$template] = $start . $addcode . $end;
	}
}

// ##### run str_replace() on templates #######################################
if (!function_exists('vba_template_alter'))
{
	function vba_template_alter($name, $find, $replace)
	{
		global $vbulletin;

		$processed = false;

		($hook = vBulletinHook::fetch_hook('vba_cmps_template_alter')) ? eval($hook) : false;

		if ($processed)
		{
			return;
		}

		$vbulletin->templatecache[$name] = str_replace(
			$find,
			$replace,
			$vbulletin->templatecache[$name]
		);
	}
}

// ##### Compability for 3.0.1 and older modules ##############################
function cmps_template_alter($name, $find, $replace)
{
	vba_template_alter($name, $find, $replace);
}

// ##### Template replacements function #######################################
if (!function_exists('replace_template_filenames'))
{
	function replace_template_filenames($tempname, $extrafiles = array())
	{
		global $vbulletin, $vba_options;

		global $repfiles;

		$repfiles = array('find' => array(), 'replace' => array());
		$optreplace = explode("\r\n", $vba_options['global_' . $tempname . '_replace']);

		if (!empty($optreplace))
		{
			foreach ($optreplace AS $filename)
			{
				if (trim($filename))
				{
					$repfiles['find'][] = '"' . $filename;
					$repfiles['replace'][] = '"' . $vbulletin->options['bburl'] . '/' . $filename;
				}
			}
		}

		if (!empty($extrafiles['find']))
		{
			$repfiles['find'] = array_merge($repfiles['find'], $extrafiles['find']);
		}

		if (!empty($extrafiles['replace']))
		{
			$repfiles['replace'] = array_merge($repfiles['replace'], $extrafiles['replace']);
		}

		if (empty($repfiles))
		{
			return;
		}

		vba_template_alter($tempname,
			$repfiles['find'],
			$repfiles['replace']
		);
	}
}

// ##### Begin Template Replacements
if (THIS_SCRIPT == 'adv_index' OR defined('ADV_DO_REPLACE'))
{
	// Head include replacements
	vba_template_alter('headinclude',
		array(
			'"clientscript',
			'url(images/',
			'name="generator" content="',
			'"external.php'
		),
		array(
			'"' . $vbulletin->options['bburl'] . '/clientscript',
			'url(' . $vbulletin->options['bburl'] . '/images/',
			'name="generator" content="vBadvanced, ',
			'"' . $vbulletin->options['bburl'] . '/external.php'
		)
	);

	vba_template_alter('headinclude_bottom',
		array(
			'"clientscript',
			'"\' . htmlspecialchars($vbcsspath) . \'', // vB 4.0.1 & prior
			'"\' . $vbcsspath . \'',										// vB 4.0.2+
			'url(images/'
		),
		array(
			'"' . $vbulletin->options['bburl'] . '/clientscript',
			'"' . $vbulletin->options['bburl'] . '/\' . htmlspecialchars($vbcsspath) . \'',
			'"' . $vbulletin->options['bburl'] . '/\' . $vbcsspath . \'',
			'url(' . $vbulletin->options['bburl'] . '/images/'
		)
	);

	// navbar template replacements
	replace_template_filenames(
		'navbar',
		array(
			'find' => array(
				'"clientscript',
				'\'misc.php',
				'>" . $GLOBALS[\'vbulletin\']->options[\'bbtitle\'] . "',
				'"" . $GLOBALS[\'vbulletin\']->options[\'forumhome\'] . ".php'
			),
			'replace' => array(
				'"' . $vbulletin->options['bburl'] . '/clientscript',
				'\'' . $vbulletin->options['bburl'] . '/misc.php',
				'>" . $GLOBALS[\'vbulletin\']->options[\'hometitle\'] . "',
				'"" . $vba_options[\'portal_homeurl\'] . "'
			)
		)
	);

	$hookreplacenames = array(
		'navbar_buttons_left',
		'navbar_buttons_right',
		'navbar_search_menu',
		'navbar_quick_links_menu_pos1',
		'navbar_quick_links_menu_pos2',
		'navbar_quick_links_menu_pos3'
	);

	if (!empty($repfiles))
	{
		foreach ($hookreplacenames AS $hookr)
		{
			if (!$template_hook[$hookr])
			{
				continue;
			}

			$template_hook[$hookr] = str_replace(
				$repfiles['find'],
				$repfiles['replace'],
				$template_hook[$hookr]
			);
		}
	}

	$vbphrase['private_messages_nav'] = str_replace('"private.php', '"' . $vbulletin->options['bburl'] . '/private.php', $vbphrase['private_messages_nav']);

	// $footer replacement
	replace_template_filenames('footer');

	$vbulletin->config['Misc']['admincpdir'] = $vbulletin->options['bburl'] . '/' . $vbulletin->config['Misc']['admincpdir'];
	$vbulletin->config['Misc']['modcpdir'] = $vbulletin->options['bburl'] . '/' . $vbulletin->config['Misc']['modcpdir'];

	if ($vbulletin->options['contactuslink'] == 'sendmessage.php')
	{
		$vbulletin->options['contactuslink'] = $vbulletin->options['bburl'] . '/sendmessage.php';
	}

	if ($vbulletin->userinfo['pmunread'])
	{
		vba_template_alter(
			'pm_popup_script',
			'= "\' . $pmpopupurl',
			'= "' . $vbulletin->options['bburl'] . '/\' . $pmpopupurl'
		);
	}

	// Cron replacement
	$cronimage = '';
	if ($vbulletin->cron <= TIMENOW)
	{
		$cronimage = '<img src="' . $vbulletin->options['bburl'] . '/cron.php?' . $vbulletin->session->vars['sessionurl'] . '&amp;rand=' . vbrand(1, 1000000) . '" alt="" width="1" height="1" border="0" />';
		$vbulletin->cron = TIMENOW;
	}

	// $header replacement
	replace_template_filenames('header');
}

// Process CSS files
$vba_cssinclude[] = 'adv_portal.css';
$vba_headinclude = '';

/* template hooks could be used here, but they were not added until vB 4.0.2 so
we'll stick with this for a bit */
foreach (array_unique($vba_cssinclude) AS $cssfile)
{
	if ($vbulletin->options['storecssasfile'])
	{
		$vba_headinclude .= '<link rel="stylesheet" type="text/css" href="' . $vbulletin->options['bburl'] . '/\' . $vbcsspath . \'' . $cssfile . "\" />\r\n";
	}
	else
	{
		$vba_headinclude .= $cssfile . ',';
	}
}

if (!$vbulletin->options['storecssasfile'])
{
	$vba_headinclude = '<link rel="stylesheet" type="text/css" href="' . $vbulletin->options['bburl'] . '/\' . $vbcsspath . \'' . substr($vba_headinclude, 0, -1) . "\" />\r\n";
}

$show['customizepagelink'] = false;

// Customize page
if ($pages['customize'] AND $vbulletin->userinfo['userid'])
{
	if ($_REQUEST['customizepage'])
	{
		$show['customizepagelink'] = substr($_SERVER['REQUEST_URI'], 0, -16);

		$show['customizepage'] = true;

		$vbacols_jsbits = '';
		$jscount = 0;
		foreach ($vba_options['portal_column_array'] AS $colid => $colname)
		{
			$vbacols_jsbits .= 'cmps_cols[' . $jscount . "] = $colid;\r\n";
			$jscount++;
		}

		$vba_headinclude .= "\r\n<script type=\"text/javascript\">\r\n<!--\r\nVB_URL = \'" . $vbulletin->options['bburl'] . "\'\r\nCMPS_PAGEID = \'$pages[pageid]\';\r\ncmps_cols = new Array();\r\n$vbacols_jsbits//-->\r\n</script>";
	}
	else
	{
		$show['customizepagelink'] = $_SERVER['REQUEST_URI'] . (strpos($_SERVER['REQUEST_URI'], '?') ? '&amp;' : '?') . 'customizepage=1';
	}
}

$vba_headinclude .= '<script type="text/javascript">
<!--
function vba_attach_win(threadid)
{
	openWindow(\\\'misc.php?' . $vbulletin->session->vars['sessionurl'] . 'do=showattachments&t=\\\' + threadid, 480, 300);
}
-->
</script>';

vbacmps_alter_vb_template(
	'headinclude' . ($vbulletin->options['simpleversion'] > 401 ? '_bottom' : ''),
	$vba_headinclude,
	true
);


// Process PHP file pages here to avoid having to globalize variables
if ($pages['type'] == 'php_file' AND $vba_cusmodid)
{
	ob_start();
	require($pages['template']);
	$home[$vba_cusmodid]['content'] = ob_get_contents();
	ob_end_clean();
}

// Don't allow collapsing for guests if homepage caching is allowed
if (!$vbulletin->userinfo['userid'] AND $vba_options['portal_guestcache'] AND $pages['name'] == 'home')
{
	unset($vbcollapse);
}

?>